#include "interactive_debugger.h"
#include <iostream>
#include <string>
#include <sstream>

void InteractiveDebugger::dbg()
{
	while(1)
	{
		std::cout << "dbg > ";
		std::string cmd;
		std::getline(std::cin, cmd);
		if(cmd == "p") break;
		if(cmd == "ptrs")
		{
			std::cout << "SP = " << m_state.sp << "\n" << "IP = " << m_state.ip << "\n";
		}
		else if(cmd == "stack")
		{
			std::cout << "STACK = [";
			for(int i = 0; i < m_state.sp; ++i) std::cout << m_state.stack[i] << (i == m_state.sp-1?"":" ");
			std::cout << "]\n";
		}
		else if(cmd == "instr")
		{
			std::cout << "ICODE = " << m_state.program_memory[m_state.ip] << "\n";
		}
		else if(cmd.substr(0, 4) == "mem ")
		{
			std::istringstream memcmd(cmd);
			unsigned offset, length;
			memcmd >> cmd >> offset >> length;
			if(memcmd.bad() || offset >= m_state.memory.size() || offset+length >= m_state.memory.size())
			{
				std::cout << "mem: invalid parameters\n";
			}
			else
			{
				std::cout << "RAM " << offset << ":" << length << " = [";
				for(int i = offset; i <= length; ++i)
				{
					std::cout << m_state.memory[i] << (i == length?"":" ");
				}
				std::cout << "]\n";
			}
		}
		else
		{
			std::cout << "Invalid command: [" << cmd << "]\n";
		}
	}
}
