#ifndef PROCESSOR_H
#define PROCESSOR_H

#include <stdint.h>
#include "vm_state.h"

///@class Processor
///@brief Abstract virtual machine processor
class Processor
{
public:
	Processor (VMState& state):m_state(state){}
	
public:
	///@method handleInstruction
	///@brief Children must implement instruction processing here
	virtual void handleInstruction(int32_t icode) = 0;
	
protected:
	VMState& m_state;
};

#endif //PROCESSOR_H
